/*-
 * Copyright 2010 aian. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AIAN ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL aian OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of aian.
 */
#ifndef ALPAKA__RESULT_SET_H
#define ALPAKA__RESULT_SET_H

#include <iosfwd>
#include <vector>

namespace alpaka {
class Failure;
class ResultSet {
public:
  friend std::ostream& operator<<(std::ostream& lhs, const ResultSet& rhs);
public:
  ResultSet() throw ();
  virtual ~ResultSet() throw ();
private:  // no implement
  ResultSet(const ResultSet& other) throw ();
  ResultSet& operator=(const ResultSet& other) throw ();
public:
  void add(const Failure& result) throw ();
  int count() const throw ();
  void clear() throw ();
private:
  std::vector<Failure*> results_;
};

std::ostream&
operator<<(std::ostream& lhs, const alpaka::ResultSet& rhs);

}

#endif  // ALPAKA__RESULT_SET_H
