#include "local.h"

class TestSample {
public:
  TestSample() {};
  virtual ~TestSample() {};
public:
  void thrower() { throw 1; };
  void unthrower() { };
};

TEST(alpaka_test, check_ok) {
  CHECK_EQ(1, 1);
  CHECK_NE(0, 1);
  CHECK_GE(2, 1);
  CHECK_GE(2, 2);
  CHECK_LE(1, 3);
  CHECK_LE(1, 1);
  CHECK_GT(3, 1);
  CHECK_LT(1, 3);
  CHECK_TRUE(1 == 1);
  CHECK_FALSE(1 == 0);
}

TEST(alpaka_test, check_ng) {
  CHECK_EQ(1, 0);
  CHECK_NE(1, 1);
  CHECK_GE(1, 2);
  CHECK_GE(1, 2);
  CHECK_LE(3, 1);
  CHECK_LE(3, 1);
  CHECK_GT(1, 3);
  CHECK_LT(3, 1);
  CHECK_TRUE(1 == 0);
  CHECK_FALSE(1 == 1);
  /* If all checking failed, this test is success. */
  if(result->count() == 10) {
    result->clear();
  }
}

TEST(alpaka_test, check_throw_ok) {
  TestSample ts;
  CHECK_NOTHROW(ts.unthrower());
  CHECK_THROW(ts.thrower());
}

TEST(alpaka_test, check_throw_ng) {
  TestSample ts;
  CHECK_THROW(ts.unthrower());
  CHECK_NOTHROW(ts.thrower());
  /* If all checking failed, this test is success. */
  if(result->count() == 2) {
    result->clear();
  }
}

TEST(alpaka_test, assert_ok) {
  ASSERT_EQ(1, 1);
  ASSERT_NE(0, 1);
  ASSERT_GE(2, 1);
  ASSERT_GE(2, 2);
  ASSERT_LE(1, 3);
  ASSERT_LE(1, 1);
  ASSERT_GT(3, 1);
  ASSERT_LT(1, 3);
}

TEST(alpaka_test, assert_ng) {
  ASSERT_EQ(1, 0);
  ASSERT_NE(1, 1);
  ASSERT_GE(1, 2);
  ASSERT_GE(1, 2);
  ASSERT_LE(3, 1);
  ASSERT_LE(3, 1);
  ASSERT_GT(1, 3);
  ASSERT_LT(3, 1);
  /* If all assertion failed, this test is success. */
  if(result->count() == 8) {
    result->clear();
  }
}

int
main(int argc, char* argv[]) {
  alpaka::TestRegistry& tr = alpaka::TestRegistry::instance();
  tr.run();
  return 0;
}
